//+------------------------------------------------------------------+
//|                                                  Aroon.mq4 |
//|                                     Copyright  2004, SelfProfit |
//|                                        http://www.selfprofit.com |
//
//|    If you find this indicator helpful, please leave a donation for the author. :)
//|    My PayPal login :  forex@selfprofit.com
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, Dmitry Alhimovich"
#property link      "http://www.selfprofit.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 White


extern int       period = 20; 
extern bool       ShowOsc = false; 


//---- buffers
double AroonUp[];
double AroonDown[];
double AroonOsc[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AroonUp);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,AroonDown);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,AroonOsc);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      string short_name = "Aroon("+period+")";
      IndicatorShortName(short_name);
   
 // ObjectCreate("selfprofit_link", OBJ_LABEL, 0, 0,0);
 // ObjectSet("selfprofit_link", OBJPROP_XDISTANCE,0);
 // ObjectSet("selfprofit_link", OBJPROP_YDISTANCE, 10);  
 // ObjectSetText("selfprofit_link", "www.selfprofit.com", 11, "Verdana", White );      
  
   int    counted_bars=IndicatorCounted();

   
 //  int countBars = 500;
   int i = 1;     
      
   int barsToCount = Bars - counted_bars;
      
   while(i <= barsToCount)
   {


     double difUp = period - (Highest(NULL, 0, MODE_HIGH, period+1, i)-i);
     AroonUp[i] = difUp / period * 100;                   
     
     double difDown = period - (Lowest(NULL, 0, MODE_LOW, period+1, i)-i);
     AroonDown[i] = difDown / period * 100;                   


     if(ShowOsc)
         AroonOsc[i] = AroonUp[i] - AroonDown[i];
      
      
      

   i++;
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+